Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 0e673013 2019-01-02 stsp # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 003cc5a3 2019-08-08 stsp export GOT_AUTHOR="Flan Hacker <flan_hacker@openbsd.org>"
18 c3754a5b 2019-05-10 stsp
19 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
20 7b67836a 2019-05-10 stsp
21 0e673013 2019-01-02 stsp function git_init
22 0e673013 2019-01-02 stsp {
23 0e673013 2019-01-02 stsp git init -q "$@"
24 0e673013 2019-01-02 stsp }
25 0e673013 2019-01-02 stsp
26 0e673013 2019-01-02 stsp function git_commit
27 0e673013 2019-01-02 stsp {
28 0e673013 2019-01-02 stsp local repo="$1"
29 0e673013 2019-01-02 stsp shift
30 0e673013 2019-01-02 stsp (cd $repo && git commit -q -a "$@")
31 0e673013 2019-01-02 stsp }
32 0e673013 2019-01-02 stsp
33 512f0d0e 2019-01-02 stsp function git_rm
34 512f0d0e 2019-01-02 stsp {
35 512f0d0e 2019-01-02 stsp local repo="$1"
36 512f0d0e 2019-01-02 stsp shift
37 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
38 512f0d0e 2019-01-02 stsp }
39 512f0d0e 2019-01-02 stsp
40 9c4b8182 2019-01-02 stsp function git_show_head
41 9c4b8182 2019-01-02 stsp {
42 9c4b8182 2019-01-02 stsp local repo="$1"
43 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
44 9c4b8182 2019-01-02 stsp }
45 9c4b8182 2019-01-02 stsp
46 818c7501 2019-07-11 stsp function git_show_parent_commit
47 818c7501 2019-07-11 stsp {
48 818c7501 2019-07-11 stsp local repo="$1"
49 818c7501 2019-07-11 stsp (cd $repo && git show --no-patch --pretty='format:%P')
50 818c7501 2019-07-11 stsp }
51 818c7501 2019-07-11 stsp
52 03415a1a 2019-06-02 stsp function git_show_tree
53 03415a1a 2019-06-02 stsp {
54 03415a1a 2019-06-02 stsp local repo="$1"
55 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
56 03415a1a 2019-06-02 stsp }
57 03415a1a 2019-06-02 stsp
58 818c7501 2019-07-11 stsp function trim_obj_id
59 818c7501 2019-07-11 stsp {
60 818c7501 2019-07-11 stsp let trimcount=$1
61 818c7501 2019-07-11 stsp id=$2
62 818c7501 2019-07-11 stsp
63 818c7501 2019-07-11 stsp pat=""
64 818c7501 2019-07-11 stsp while [ trimcount -gt 0 ]; do
65 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
66 818c7501 2019-07-11 stsp let trimcount--
67 818c7501 2019-07-11 stsp done
68 818c7501 2019-07-11 stsp
69 818c7501 2019-07-11 stsp echo ${id%$pat}
70 818c7501 2019-07-11 stsp }
71 818c7501 2019-07-11 stsp
72 03415a1a 2019-06-02 stsp function git_commit_tree
73 03415a1a 2019-06-02 stsp {
74 03415a1a 2019-06-02 stsp local repo="$1"
75 03415a1a 2019-06-02 stsp local msg="$2"
76 03415a1a 2019-06-02 stsp local tree="$3"
77 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
78 03415a1a 2019-06-02 stsp }
79 03415a1a 2019-06-02 stsp
80 0e673013 2019-01-02 stsp function make_test_tree
81 0e673013 2019-01-02 stsp {
82 0e673013 2019-01-02 stsp repo="$1"
83 0e673013 2019-01-02 stsp
84 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
85 0e673013 2019-01-02 stsp echo beta > $repo/beta
86 0e673013 2019-01-02 stsp mkdir $repo/gamma
87 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
88 0e673013 2019-01-02 stsp mkdir $repo/epsilon
89 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
90 0e673013 2019-01-02 stsp }
91 0e673013 2019-01-02 stsp
92 3ce1b845 2019-07-15 stsp function get_blob_id
93 3ce1b845 2019-07-15 stsp {
94 3ce1b845 2019-07-15 stsp repo="$1"
95 3ce1b845 2019-07-15 stsp tree_path="$2"
96 3ce1b845 2019-07-15 stsp filename="$3"
97 3ce1b845 2019-07-15 stsp
98 3ce1b845 2019-07-15 stsp got tree -r $repo -i $tree_path | grep ${filename}$ | cut -d' ' -f 1
99 3ce1b845 2019-07-15 stsp }
100 3ce1b845 2019-07-15 stsp
101 0e673013 2019-01-02 stsp function test_init
102 0e673013 2019-01-02 stsp {
103 0e673013 2019-01-02 stsp local testname="$1"
104 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
105 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
106 0e673013 2019-01-02 stsp echo "No test name provided" >&2
107 0e673013 2019-01-02 stsp return 1
108 0e673013 2019-01-02 stsp fi
109 0e673013 2019-01-02 stsp local testroot=`mktemp -p /tmp -d got-test-$testname-XXXXXXXX`
110 0e673013 2019-01-02 stsp mkdir $testroot/repo
111 0e673013 2019-01-02 stsp git_init $testroot/repo
112 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
113 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
114 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
115 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
116 4a1ddfc2 2019-01-12 stsp fi
117 0e673013 2019-01-02 stsp echo "$testroot"
118 0e673013 2019-01-02 stsp }
119 0e673013 2019-01-02 stsp
120 0e673013 2019-01-02 stsp function test_cleanup
121 0e673013 2019-01-02 stsp {
122 0e673013 2019-01-02 stsp local testroot="$1"
123 fe7842f5 2019-07-14 stsp
124 fe7842f5 2019-07-14 stsp (cd $testroot/repo && git fsck --strict \
125 fe7842f5 2019-07-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
126 fe7842f5 2019-07-14 stsp ret="$?"
127 fe7842f5 2019-07-14 stsp if [ "$ret" != "0" ]; then
128 fe7842f5 2019-07-14 stsp echo -n "git fsck: "
129 fe7842f5 2019-07-14 stsp cat $testroot/fsck.stderr
130 fe7842f5 2019-07-14 stsp echo "git fsck failed; leaving test data in $testroot"
131 fe7842f5 2019-07-14 stsp return 1
132 fe7842f5 2019-07-14 stsp fi
133 fe7842f5 2019-07-14 stsp
134 0e673013 2019-01-02 stsp rm -rf "$testroot"
135 0e673013 2019-01-02 stsp }
136 0e673013 2019-01-02 stsp
137 0e673013 2019-01-02 stsp function run_test
138 0e673013 2019-01-02 stsp {
139 0e673013 2019-01-02 stsp testfunc="$1"
140 370629d7 2019-01-02 stsp echo -n "$testfunc "
141 0e673013 2019-01-02 stsp $testfunc
142 0e673013 2019-01-02 stsp }
143 0e673013 2019-01-02 stsp
144 0e673013 2019-01-02 stsp function test_done
145 0e673013 2019-01-02 stsp {
146 0e673013 2019-01-02 stsp local testroot="$1"
147 0e673013 2019-01-02 stsp local result="$2"
148 0e673013 2019-01-02 stsp if [ "$result" == "0" ]; then
149 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
150 370629d7 2019-01-02 stsp echo "ok"
151 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
152 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
153 3941b73a 2019-05-14 stsp echo "$result"
154 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
155 0e673013 2019-01-02 stsp else
156 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
157 0e673013 2019-01-02 stsp fi
158 0e673013 2019-01-02 stsp }